/*
 * Copyright 2008 Jerome Glisse <glisse@freedesktop.org>
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that this copyright notice and this permission notice appear in
 * supporting electronic documentation.
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR AUTHORS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
#ifndef DUMP_H
#define DUMP_H

#include "list.h"

struct mmreg
{
    struct list_head    list;
    unsigned            offset;
    unsigned            value;
};

struct ixreg
{
    struct list_head    list;
    unsigned            index;
    unsigned            data;
    unsigned            offset;
    unsigned            value;
};

struct dump
{
    unsigned            pciid;
    unsigned            cmmregs;
    unsigned            cixregs;
    struct list_head    mmregs;
    struct list_head    ixregs;
};

void dump_init(struct dump *dump);
void dump_fini(struct dump *dump);
void dump_add_mmreg(struct dump *dump, struct mmreg *mmreg);
void dump_add_ixreg(struct dump *dump, struct ixreg *ixreg);

struct mmreg *mmreg_new(unsigned o, unsigned v);
struct ixreg *ixreg_new(unsigned idx, unsigned ida, unsigned o, unsigned v);

int dump_xml_read(struct dump *dump, const char *filename);
int dump_xml_write(struct dump *dump, const char *filename);

#endif
